package Zinema;

public class Butaka {
	private int k=0;
	private int z=0;
	private boolean h=false;
	private boolean l=true;
	private boolean u=true;
	private int temp;
	private boolean flag=true;
	
	private int EL;
	private int IK;
	private Pantaila p;
	private boolean[] libre;
	
	public Butaka(int EL, int IK, Pantaila p, boolean[] libre) {
		this.EL=EL;
		this.IK=IK;
		this.p=p;
		this.libre=libre;
	}
	
	synchronized public int eserlekuLibre() throws InterruptedException{
		//when (k<=EL&&h==0&&u==1)			i[RIK].eserlekuLibre[EL-k]	->	BUTAKAK[k+1][z][h][l][u][b1][b2][b3]
		while(!(k<EL&&h==false&&u==true)) wait();
		temp=EL-k;
		k++;
		notifyAll(); //eserluak erosteko zain daudenak esnatu behar dira
		return temp;
	}

	synchronized public void sartu(int id) throws InterruptedException{
		//when (z<IK)						i[RIK].sartu				->	BUTAKAK[k][z+1][h][l][u][b1][b2][b3]
		while(!(z<IK)) wait();
		z++;
		p.sartu(id);
		notifyAll(); //Akomodadorea esnatzen dela ziurtatu behar da
	}

	synchronized public int begiratu(int id) throws InterruptedException{
		//									i[RIK].begiratu[b1][b2][b3]	->	BUTAKAK[k][z][h][l][u][b1][b2][b3]
		while (!(flag==true)) wait();
		flag =	false;
		for(int i=0; i<EL; i++) {
			if(libre[i]) {
				return i;
			}
		}
		return -1;
	}
	
	synchronized public void eseri(int id, int i) throws InterruptedException{
		//when (l==0)						i[RIK].eseri->	if(b1==1) then BUTAKAK[k][z][h][1][u][0][b2][b3]
		//													else if (b2==1) then BUTAKAK[k][z][h][1][u][b1][0][b3]
		//													else if (b3==1) then BUTAKAK[k][z][h][1][u][b1][b2][0]
		while(!(l==false)) wait();
		flag = true;
		l=true;
		libre[i]=false;
		p.eseri(id);
		notifyAll(); //Akomodadorea esnatzen dela ziurtatu behar da
	}

	synchronized public void irten(int id, int i) throws InterruptedException{
		//when (k>0)						i[RIK].irten->	if(b1==0) then BUTAKAK[k-1][z][h][l][u][1][b2][b3]
		//													else if (b2==0) then BUTAKAK[k-1][z][h][l][u][b1][1][b3]
		//													else if (b3==0) then BUTAKAK[k-1][z][h][l][u][b1][b2][1]
		while(!(k>0)) wait();
		k--;
		libre[i]=true;
		p.irten(id);
		if (k==0) { //Zinema hustutakoan hustu exekutatzen dela ziurtatu behar da baina soilik hustutzen denean
			notifyAll(); //Zinema hustu da eta filma esnatu behar da
		}
		
	}

	synchronized public void hasi() throws InterruptedException{
		//when (z==0&&u==1)					film.hasi					->  BUTAKAK[k][z][1][l][0][b1][b2][b3]
		while (!(z==0&&u==true)) wait();
		h=true;
		u=false;
		p.hasi();
	}

	synchronized public void amaitu() throws InterruptedException{
		//when (h==1)						film.amaitu					->  BUTAKAK[k][z][0][l][u][b1][b2][b3]
		while(!(h==true)) wait();
		h=false;
		p.amaitu();
		notifyAll(); //Ikusleak esnatzen direla ziurtatu behar da
	}

	synchronized public void hustu() throws InterruptedException{
		//when (k==0)						film.hustu					->  BUTAKAK[k][z][h][l][1][b1][b2][b3]
		while(!(k==0)) wait();
		u=true;
		p.hustu();
	}

	synchronized public void lagundu() throws InterruptedException{
		//when (z>0&&l==1)					ako.lagundu					->	BUTAKAK[k][z-1][h][0][u][b1][b2][b3]
		while(!(z>0&&l==true)) wait();
		l=false;
		p.lagundu();
		z--;
		notifyAll(); //Ziurtatu behar da ikusleren bat esnatzen dela
	}
	
	synchronized public boolean bukatuDa() throws InterruptedException{
		//									i[RIK].bukatuDa[h]			->	BUTAKAK[k][z][h][l][u][b1][b2][b3]
		notifyAll(); //Ikusle guztiei abixatu behar zaie bukatu dela
		return h;
	}
}
